package desmoj.core.report;

/**
 * Implementation of DESMO-J OutputType which act similar to unix /dev/null
 * simmply ignoring all received messaged and reporters. It also doesn't create
 * any system resource. 
 * This implementation can be used if you want to suppress creation of default file(s)
 * with experiment output.
 *
 * @author Nicolas Knaak
 * @version DESMO-J, Ver. 2.3.3 copyright (c) 2011
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You
 * may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
public class NullOutput implements OutputType {
 
	public void setTimeFloats(int timeFloats) {
        // do nothing
    }
 
    public void open(String pathname, String name) {
        // do nothing
    }
 
    public String getAppendix() {
        return ""; //$NON-NLS-1$
    }
 
    public void receive(Message m) {
        // do nothing
    }
 
    public void receive(Reporter r) {
        // do nothing
    }
    
    public void close() {
    	// do nothing
    }
}